//
// File: INITCNT.H
//
// Contents: This class is to provide an initialization count
//             facility to allow for current instansiation of
//             "Singleton" class etc.
//
// Designer/Programmer: John Hartley
//
// Date: 4/7/95
//
// Version: 1.0
//
// License:
// Copyright (c) 1995 Graphica Software Pty. Ltd.
// This software is part of the "ObjectBlocks" (TM) reusable components library.
// Its use is allowed only if this notice is included intact and
// on the basis of permission being granted by the copyright holder.
// Graphica Software Pty. Ltd.
// 851 Brunswick St. North
// North Fitzroy 3068
// Victoria, Australia.
// Ph:  + 61 3 9481 3747
// Fax: + 61 3 9481 3747 
//

#ifndef INITCNT_H
#define INITCNT_H

#define INITCNT_HEADER(T) static InitCounter<T > T##_InitCnt;
#define INITCNT_DEFINE(T) int InitCounter<T >::Cnt = 0;

template <class T > class InitCounter {
public:
  InitCounter() {
    if (Cnt++ == 0) {
      T::Start();
    }
  }
  ~InitCounter() {
    if (--Cnt == 0) {
      T::Stop();
    }
  }
private:
  static int Cnt;
};

#endif
 
