/*
 * File: winstdio.c
 *
 * Contents: Create stdio handles by opening a console.
 *
 * Programmer: John Hartley
 *
 * Version; 1.0
 *
 * Date: 24/4/97
 *
 * License:
 * Copyright (c) 1997 Graphica Software Pty. Ltd.
 * This software is part of the "ObjectBlocks" (TM) reusable components library.
 * Its use is allowed only if this notice is included intact and
 * on the basis of permission being granted by the copyright holder.
 * Graphica Software Pty. Ltd.
 * 851 Brunswick St. North
 * North Fitzroy 3068
 * Victoria, Australia.
 * Ph:  + 61 3 9481 3747
 * Fax: + 61 3 9481 3747
 * Email: info@melb.graphica.com.au
 * http://www.graphica.com.au
 *
 */

#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <windows.h>

#include "winstdio.h"

static int hStdIn = 0,
           hStdOut = 0,
           hStdErr = 0;

void StdIoConsole(int bOpen)
{
  switch (bOpen) {
    case 1: AllocConsole();
            hStdOut = _open_osfhandle((long)GetStdHandle(STD_OUTPUT_HANDLE),
                                      _O_TEXT);
            hStdErr = _open_osfhandle((long)GetStdHandle(STD_ERROR_HANDLE),
                                      _O_TEXT);
            hStdIn = _open_osfhandle((long)GetStdHandle(STD_INPUT_HANDLE),
                                     _O_TEXT);
            *stdout = *fdopen(hStdOut, "w");
            *stderr = *fdopen(hStdErr, "w");
            *stdin = *fdopen(hStdIn, "r");
            setvbuf(stdout, NULL, _IONBF, 0);
            setvbuf(stderr, NULL, _IONBF, 0);
            setvbuf(stdin, NULL, _IONBF, 0);
            break;
    default: FreeConsole();
             break;
  }
}
