//
// File: wnioinit.cpp
//
// Contents: Automatically create a console for
//           stdin, stdout and stderr.
//           Based on the value of the following
//           compiler flags:
//           _STDIO_LOG_     - do init, send to log
//           _STDIO_CONSOLE_ - do init, send to console
//
// Programmer: John Hartley
//
// Version: 1.0
//
// Date: 24/4/97
//
// License:
// Copyright (c) 1997 Graphica Software Pty. Ltd.
// This software is part of the "ObjectBlocks" (TM) reusable components library.
// Its use is allowed only if this notice is included intact and
// on the basis of permission being granted by the copyright holder.
// Graphica Software Pty. Ltd.
// 851 Brunswick St. North
// North Fitzroy 3068
// Victoria, Australia.
// Ph:  + 61 3 9481 3747
// Fax: + 61 3 9481 3747
// Email: info@melb.graphica.com.au
// http://www.graphica.com.au
//

#include "wnioinit.h"
#include "winstdio.h"

#if defined(_STDIO_CONSOLE_)

INITCNT_DEFINE(WinStdIOInit)

// #if defined(_STDIO_LOG_)
// #elsif defined(_STDIO_CONSOLE_)
// #endif

void WinStdIOInit::Start()
{
  StdIoConsole(1);
}

void WinStdIOInit::Stop()
{
  StdIoConsole(0);
}

#endif
